﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace MediaElementLimit
{
    public partial class Page : UserControl
    {
        private int _posX = 0;
        private int _posY = 0;
        private int _maxX = 9;

        public Page()
        {
            InitializeComponent();

            imgLogo.MouseLeftButtonUp += new MouseButtonEventHandler(imgLogo_MouseLeftButtonUp);
        }

        void imgLogo_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            HtmlPage.Window.Navigate(new Uri("http://hugeflow.com", UriKind.Absolute), "_blank");
        }

        private void Image_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            AddMedia();
        }

        private void AddMedia()
        {
            if (_posX > _maxX)
            {
                _posX = 0;
                _posY++;
            }

            if (_posY >= 14)
                return;

            MediaElement me = new MediaElement();
            me.Source = new Uri("Media/fy.wma", UriKind.Relative);
            me.CurrentStateChanged += new RoutedEventHandler(me_CurrentStateChanged);
            me.Volume = 1;

            // Media Naming
            int number = _posY * 10 + _posX + 1;
            me.SetValue(MediaElement.NameProperty, number.ToString());

            LayoutRoot.Children.Add(me);

            PlayButton playButton = new PlayButton();
            playButton.SetValue(Canvas.LeftProperty, 32 * _posX);
            playButton.SetValue(Canvas.TopProperty, 30 * _posY);
            playButton.Media = me;
            cvMedia.Children.Add(playButton);

            _posX++;
        }

        void me_CurrentStateChanged(object sender, RoutedEventArgs e)
        {
            MediaElement me = sender as MediaElement;

            if (me == null)
                return;

            OutputMessage(string.Format("{0} = {1}", me.Name, me.CurrentState.ToString()));
        }

        public void OutputMessage(string message)
        {
            if (message == null)
                return;

            tbStatus.Text = message;
        }

        private void Image10_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            for (int i = 0; i < 10; i++)
            {
                AddMedia();
            }
        }
    }
}
